VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Stream In to RTB"
   ClientHeight    =   4830
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8325
   LinkTopic       =   "Form1"
   ScaleHeight     =   4830
   ScaleWidth      =   8325
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command4 
      Caption         =   "Simulate Stream of Chunks"
      Enabled         =   0   'False
      Height          =   855
      Left            =   7305
      TabIndex        =   5
      Top             =   975
      Width           =   1005
   End
   Begin VB.CommandButton Command3 
      Caption         =   "RTB Load Method..."
      Height          =   810
      Left            =   7305
      TabIndex        =   3
      Top             =   3990
      Width           =   1005
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Open file to Text Property..."
      Height          =   810
      Left            =   7305
      TabIndex        =   2
      Top             =   3105
      Width           =   1005
   End
   Begin MSComDlg.CommonDialog cd1 
      Left            =   7485
      Top             =   4080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Stream In File as Text..."
      Height          =   855
      Left            =   7305
      TabIndex        =   1
      Top             =   45
      Width           =   1005
   End
   Begin RichTextLib.RichTextBox RTB 
      Height          =   4875
      Left            =   -30
      TabIndex        =   0
      Top             =   -15
      Width           =   7305
      _ExtentX        =   12885
      _ExtentY        =   8599
      _Version        =   393217
      BackColor       =   12640511
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"RTB StreamIn.frx":0000
   End
   Begin VB.Label Label1 
      Caption         =   "Typical methods"
      Height          =   480
      Left            =   7350
      TabIndex        =   4
      Top             =   2595
      Width           =   960
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'timing is not the most accurate method but it gives you the idea as long as the
'file is sufficiently large. Of course you should check times in the EXE not the IDE.

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Sub Command1_Click()
Dim t

    cd1.ShowOpen
    
    Caption = ""
    t = Timer
    StreamInFile RTB.hWnd, cd1.FileName, SF_TEXT ' SF_RTF '
Caption = Timer - t
End Sub

'simulate stream of chunks -- Append
'contrary to what you might expect from the name EM_STREAMIN
'you can't do this since the only way to add text is to alter the selection
'you could however show a small chunk to the user, then finish gathering
'the text and append it in a second large chunk.
'It's a shame there is no append method that would leave the selection alone.
Private Sub Command4_Click()
    Dim i As Long, s As String, selpos As Long
    'send in ~1MB
    s = "Blablabla "
    For i = 1 To 14
        s = s & s
        If i Mod 20 = 0 Then s = s & vbNewLine
    Next
'    StreamInStringAsByte RTB.hWnd, s, SF_TEXT Or SFF_SELECTION
    Me.MousePointer = vbArrowHourglass
    For i = 1 To 10
        Sleep 50
        selpos = RTB.SelStart
        RTB.SelStart = Len(RTB.Text) 'could replace this with the API equivalent
        Call StreamInStringAsByte(RTB.hWnd, vbNewLine & vbNewLine & "This is chunk " & i & " of 1000" & vbNewLine & s, SF_TEXT Or SFF_SELECTION)
        RTB.SelStart = selpos
        DoEvents
    Next
    Me.MousePointer = vbDefault
End Sub

'Standard set text prop. of rtb
Private Sub Command2_Click()
Dim t
    cd1.ShowOpen
    Caption = ""
    t = Timer
    RTB.Text = GetFileText(cd1.FileName)
'    RTB.TextRTF = GetFileText(cd1.FileName)
Caption = Timer - t
End Sub

'Standard use rtb LoadFile method
Private Sub Command3_Click()
Dim t
    On Error Resume Next
    cd1.ShowOpen
    Caption = ""
    t = Timer
    RTB.LoadFile cd1.FileName, rtfText 'rtfRTF
Caption = Timer - t
    If Err Then RTB.Text = Err.Description
End Sub


Private Function GetFileText(file As String) As String
Dim ii As Integer, sizeF As Long
On Error GoTo ifError

    ii = FreeFile
    Open file For Binary As ii
        sizeF = LOF(ii)
        GetFileText = Space(sizeF)
        Get ii, , GetFileText
        If Asc(Left$(GetFileText, 1)) = 0 Then Mid$(GetFileText, 1, 1) = " "
ifError:
    Close ii
End Function

Private Sub Form_Unload(Cancel As Integer)
    RTB.Text = vbNullString
End Sub
